<?php

namespace App\Http\Controllers\Resources;

use Illuminate\Http\Request;
use App\Http\Requests\ExpenseRequest;
use App\Http\Requests\ExportRequest;
use App\Http\Requests\ImportRequest;
use App\Http\ReportGenerator\PdfReport;
use App\Http\ReportGenerator\ExcelReport;
use App\Http\Controllers\Controller;
use App\Http\Filters\QueryBuilder;

use App\Expense;

class ExpenseController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $queryBuilder = new QueryBuilder(new Expense, $request);

        return response()->json($queryBuilder->build()->paginate(10),200);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  App\Http\Requests\ExpenseRequest  $request
     * @return \Illuminate\Http\Response
     */
    public function store(ExpenseRequest $request)
    {
      return response()->json(tap(new Expense($request->all()), function ($expense) {
          $expense->save();
      }), 201);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
      $expense=Expense::find($id);

  		if (!$expense) {
  			return response()->json(['errors'=>array(['code'=>404,'message'=>__('expenses.not_find')])],404);
  		}

  		return response()->json(['status'=>'ok','data'=>$expense],200);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  App\Http\Requests\ExpenseRequestt  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(ExpenseRequest $request, $id)
    {
      $expense=Expense::find($id);

      if (!$expense) {
        return response()->json(['errors'=>array(['code'=>404,'message'=>__('expenses.not_find')])],404);
      }

      return tap($expense)->update($request->all());
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
      $expense=Expense::find($id);

      if (!$expense) {
        return response()->json(['errors'=>array(['code'=>404,'message'=>__('expenses.not_find')])],404);
      }

      $expense->delete();

      return response()->json(['code'=>204,'message'=>__('strings.deleted_successfully')],204);
    }

    /**
     * Display report from a listing of the resource.
     *
     * @param  App\Http\Requests\ExportRequest $request
     * @return PDF CSV or XLS
     */
    public function export(ExportRequest $request)
    {
      $format = $request->input('format');
      $orderBy = $request->input('order_by');
      $betweenDates = ($request->input('between_dates')) ? explode(',', $request->input('between_dates')): ['',''];

      $queryBuilder = new QueryBuilder(new Expense, $request);

      $meta = [ // For displaying filters description on header
          __('strings.registered_on') => $betweenDates[0].' - '.$betweenDates[1],
          __('strings.order_by') => $orderBy,
      ];

      $columns = [ // Set Column to be displayed
          __('expenses.concept') => 'concept',
          __('expenses.amount') => 'amount',
      ];

      switch ($format) {
        case 'pdf':
          $report = new PdfReport();
          return $report->of(__('expenses.report_title'), $meta, $queryBuilder->build()->get(), $columns)->showTotal([__('expenses.amount') => '$'])->download(__('expenses.report_title'));
        case 'excel':
          $report = new ExcelReport();
          return $report->of(__('expenses.report_title'), $meta, $queryBuilder->build()->get(), $columns)->setView('reports.list-excel-template')->download(__('expenses.report_title'));
        case 'csv':
          $report = new ExcelReport();
          return $report->of(__('expenses.report_title'), $meta, $queryBuilder->build()->get(), $columns)->simple()->setFormat('csv')->download(__('expenses.report_title'));
        default:
          $report = new PdfReport();
          return $report->of(__('expenses.report_title'), $meta, $queryBuilder->build()->get(), $columns)->showTotal([__('expenses.amount') => '$'])->stream();
      }
    }
}
